---
title: Trailing commas
slug: Web/JavaScript/Reference/Trailing_commas
tags:
  - Comma
  - ECMAScript2017
  - ECMAScript5
  - JavaScript
  - Language feature
  - Syntax
  - Trailing comma
---
<div>{{JsSidebar("More")}}</div>

<p><strong>Trailing commas</strong> (sometimes called "final commas") can be useful when adding new elements, parameters, or properties to JavaScript code. If you want to add a new property, you can add a new line without modifying the previously last line if that line already uses a trailing comma. This makes version-control diffs cleaner and editing code might be less troublesome.</p>

<p>JavaScript has allowed trailing commas in array literals since the beginning, and later added them to object literals (ECMAScript 5) and most recently (ECMAScript 2017) to function parameters.</p>

<p><a href="/en-US/docs/Glossary/JSON">JSON</a>, however, disallows trailing commas.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">,</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Trailing_commas_in_literals">Trailing commas in literals</h3>

<h4 id="Arrays">Arrays</h4>

<p>JavaScript ignores trailing commas in arrays:</p>

<pre class="brush: js">var arr = [
  1,
  2,
  3,
];

arr; // [1, 2, 3]
arr.length; // 3</pre>

<p>If more than one trailing comma is used, an elision (or hole) is produced. An array with holes is called <em>sparse</em> (a <em>dense</em> array has no holes). When iterating arrays for example with {{jsxref("Array.prototype.forEach()")}} or {{jsxref("Array.prototype.map()")}}, array holes are skipped.</p>

<pre class="brush: js">var arr = [1, 2, 3,,,];
arr.length; // 5
</pre>

<h4 id="Objects">Objects</h4>

<p>Starting with ECMAScript 5, trailing commas in object literals are legal as well:</p>

<pre class="brush: js">var object = {
  foo: "bar",
  baz: "qwerty",
  age: 42,
};</pre>

<h3 id="Trailing_commas_in_functions">Trailing commas in functions</h3>

<p>ECMAScript 2017 allows trailing commas in function parameter lists.</p>

<h4 id="Parameter_definitions">Parameter definitions</h4>

<p>The following function definition pairs are legal and equivalent to each other. Trailing commas don't affect the <code>length</code> property of function declarations or their <code>arguments</code> object.</p>

<pre class="brush: js">function f(p) {}
function f(p,) {}

(p) =&gt; {};
(p,) =&gt; {};
</pre>

<p>The trailing comma also works with <a href="/en-US/docs/Web/JavaScript/Reference/Functions/Method_definitions">method definitions</a> for classes or objects:</p>

<pre class="brush: js">class C {
  one(a,) {}
  two(a, b,) {}
}

var obj = {
  one(a,) {},
  two(a, b,) {},
};
</pre>

<h4 id="Function_calls">Function calls</h4>

<p>The following function invocation pairs are legal and equivalent to each other.</p>

<pre class="brush: js">f(p);
f(p,);

Math.max(10, 20);
Math.max(10, 20,);
</pre>

<h4 id="Illegal_trailing_commas">Illegal trailing commas</h4>

<p>Function parameter definitions or function invocations only containing a comma will throw a {{Jsxref("SyntaxError")}}. Furthermore, when using a <a href="/en-US/docs/Web/JavaScript/Reference/Functions/rest_parameters">rest parameters</a>, trailing commas are not allowed:</p>

<pre class="brush: js example-bad">function f(,) {} // SyntaxError: missing formal parameter
(,) =&gt; {};       // SyntaxError: expected expression, got ','
f(,)             // SyntaxError: expected expression, got ','

function f(...p,) {} // SyntaxError: parameter after rest parameter
(...p,) =&gt; {}        // SyntaxError: expected closing parenthesis, got ','
</pre>

<h3 id="Trailing_commas_in_destructuring">Trailing commas in destructuring</h3>

<p>A trailing comma is also allowed on the left-hand side when using <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Destructuring_assignment">destructuring assignment</a>:</p>

<pre class="brush: js">// array destructuring with trailing comma
[a, b,] = [1, 2];

// object destructuring with trailing comma
var o = {
  p: 42,
  q: true,
};
var {p, q,} = o;
</pre>

<p>Again, when using a rest element, a {{jsxref("SyntaxError")}} will be thrown:</p>

<pre class="brush: js example-bad">var [a, ...b,] = [1, 2, 3];
// SyntaxError: rest element may not have a trailing comma</pre>

<h3 id="Trailing_commas_in_JSON">Trailing commas in JSON</h3>

<p>Trailing commas in objects were only introduced in ECMAScript 5. As JSON is based on JavaScript's syntax prior to ES5, <strong>trailing commas are not allowed in JSON</strong>.</p>

<p>Both lines will throw a <code>SyntaxError</code>:</p>

<pre class="brush: js example-bad">JSON.parse('[1, 2, 3, 4, ]');
JSON.parse('{"foo" : 1, }');
// SyntaxError JSON.parse: unexpected character
// at line 1 column 14 of the JSON data
</pre>

<p>Omit the trailing commas to parse the JSON correctly:</p>

<pre class="brush: js example-good">JSON.parse('[1, 2, 3, 4 ]');
JSON.parse('{"foo" : 1 }');</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.grammar.trailing_commas")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>Initial ECMAScript proposal: <a href="https://github.com/tc39/proposal-trailing-function-commas">trailing function commas</a> by Jeff Morrison</li>
</ul>
